function localization_demo_CRC;

% Demo for target location in white Gaussian noise.
% As template, an image of letter "O" is used
% Noise level is selected from menue
% NSR=StDevNoise/sqrt(SignalEnergy)
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il),
% Call OUTIMG=localization_demo_CRC;

figure_n(2);
m1=menu('Select','Target location on uniform background','Character location in text','Probability of anomalous errors');
switch m1,
    case 1
        Perr=0;
        m=menu('Select target','Constellation','Character');
        switch m,
            case 1,load waterman; target=waterman;
            case 2,load letter_o; target=letter_o/255;
        end
        [TSzX,TSzY]=size(target);
        Etrgt=sqrt(sum(target(:).^2));
        figure(1);imshow(kron(target,ones(10)),[]);title(['Target image ',num2str(TSzX),'x',num2str(TSzY),'; sqrt(Etrgt)=',num2str(Etrgt)],'FontWeight','Bold');drawnow
        
        m2=menu('Select noise level','0.05','0.1','0.15','0.2','0.4','0.75','1','1.5');
        NoiseLevel=[0.05,0.1,0.15,0.2,0.4,0.75,1,1.5];
        figure(2);
        for k=1:25,
        INPIMG=zeros(256);
        Xt=fix(200*rand)+28;Yt=fix(200*rand)+18;
        INPIMG(Xt,Yt)=1;INPIMG=conv2(INPIMG,target,'same');
        
        INPIMG_n=INPIMG+NoiseLevel(m2)*randn(256);
        Corr=conv2(INPIMG_n,target,'same');
        mx=max(max(Corr));
        [Xm,Ym]=find(Corr==mx);
        if size(Xm)>1,Xm=Xm(1);end
        if size(Ym)>1,Ym=Ym(1);end
%         Corr=255*Corr/mx;
        if abs(Xt-Xm)+abs(Yt-Ym)>5, Perr=Perr+1;end
        XTmn=Xt-10;if XTmn<1,XTmn=1;end
        YTmn=Yt-10;if YTmn<1,YTmn=1;end
        XTmm=Xt+10;if XTmm>256,XTmm=256;end
        YTmm=Yt+10;if YTmm>256,YTmm=256;end
        Xmn=Xm-10;if Xmn<1,Xmn=1;end
        Ymn=Ym-10;if Ymn<1,Ymn=1;end
        Xmm=Xm+10;if Xmm>256,Xmm=256;end
        Ymm=Ym+10;if Ymm>256,Ymm=256;end
%         INPIMG(Xm,Ymn:Ymm)=255;
%         INPIMG(Xmn:Xmm,Ym)=255;
        INPIMG_n(Xt,YTmn:YTmm)=max(INPIMG_n(:));
        INPIMG_n(XTmn:XTmm,Yt)=max(INPIMG_n(:));
        Corr(Xm,Ymn:Ymm)=mx;
        Corr(Xmn:Xmm,Ym)=mx;
        imshow([uquan256(INPIMG_n),128*ones(256,16),uquan256(Corr)],[]);
        title(['Input image (left) and Correlator output (right); NSR =',num2str(NoiseLevel(m2)/Etrgt),'; test#=',num2str(k),'; Perr=',num2str(Perr/25)],'FontWeight','Bold');
        drawnow
        pause(1);
        end
    case 2
        load letter_o;
        load text256;
        figure(1);
        imshow(kron(letter_o,ones(5))); title('Template image','FontWeight','Bold')
        m2=menu('Select noise level','10','20','30','40','50');
        for k=1:25,
        INPIMG=255-text256;
        INPIMG_n=INPIMG+10*m2*randn(256);
        Corr=conv2(INPIMG_n,letter_o,'same');
        mx=max(max(Corr));
        [Xm,Ym]=find(Corr==mx);
        if size(Xm)>1,Xm=Xm(1);end
        if size(Ym)>1,Ym=Ym(1);end
        
        INPIMG_n(Xm,:)=max(INPIMG(:));
        INPIMG_n(:,Ym)=max(INPIMG(:));
        figure(2)
        imshow(kron(INPIMG_n,ones(2)),[0 255]);
        title(['Detection of character "o". Noise StDev=',num2str(10*m2),'/255; test#=',num2str(k)],'FontWeight','Bold');
        drawnow
        pause(2)
        end
    case 3
%         load letter_o; target=letter_o/sqrt(sum(letter_o.^2));
        target=ones(8)/8;
        [TgSzX,TgSzY]=size(target);
        Pa=zeros(4,8);
        NoiseLevel=[0.025 0.05 0.075 0.15,0.185,0.3,0.6,1.2];
%   
        lbl=['o','*','+','d'];
        Nit=100;
%         figure(2);
        figure_n(1)
        for S=1:4,
            for Nlev=1:8,
                for k=1:Nit,
                    INPIMG=zeros(2^(5+S));
                    [SzX,SzY]=size(INPIMG);
                    INPIMG(SzX/2,SzY/2)=1;INPIMG=conv2(INPIMG,target,'same');
                    Q=(SzX*SzY/(TgSzX*TgSzY));
                    INPIMG_n=INPIMG+NoiseLevel(Nlev)*randn(SzX,SzY);
                    Corr=conv2(INPIMG_n,target,'same');
                    mx=max(max(Corr));
                    [Xm,Ym]=find(Corr==mx);
                    if size(Xm)>1,Xm=Xm(1);end
                    if size(Ym)>1,Ym=Ym(1);end
                    if abs(SzX/2-Xm)+abs(SzY/2-Ym)>3, Pa(S,Nlev)=Pa(S,Nlev)+1/Nit;end
                end
            end
            plot(sqrt(2*(NoiseLevel.^2)*log(Q)),Pa(S,:),['k-',lbl(S)],'LineWidth',2)
            set(gca,'FontWeight','Bold','FontSize',10)
            grid on; 
            xlabel('[2{\sigma}^2_nln(Q)/E_a]^1^/^2','FontWeight','Bold','FontSize',10);
            ylabel('P_A_e','FontWeight','Bold','FontSize',10)
            title('Probability of anomalous errors of localization of a target on images of different size','FontWeight','Bold')
            axis([0 sqrt(max(2*NoiseLevel.^2*log(Q))) 0 1.05]);
            drawnow
            hold on
        end
        legend('Q=64','Q=256','Q=1024','Q=4096','Location','SouthEast');
        hold off
        
end
%-----------------------------------------------------------------------------------        
 function figure_n(N)
% Generating N square figure windows of ScreenVerSz/2*ScreenVerSz pixels
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)
% Version July 15, 2001
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)  
% Call figure_n(N)

% Generating figure windows
ScrSz=get(0,'ScreenSize');
HorSz=(ScrSz(3)-20); VerSz=(ScrSz(4));
close all;

switch N;
case 1, 
   Nvert=1;Nhor=1;H_Sz=(HorSz-80); V_Sz=(VerSz-120);
   figure('Position',[30 VerSz-30-V_Sz V_Sz V_Sz]); colormap(gray(256))
case 2, 
   Nvert=1;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120);
   figure('Position',[30 VerSz-30-H_Sz H_Sz H_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-H_Sz H_Sz H_Sz]);colormap(gray(256))
case 3, 
   Nvert=2;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 4, 
   Nvert=2;Nhor=2;H_Sz=(HorSz-80)/2; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 5,
   Nvert=2;Nhor=3;H_Sz=(HorSz-80)/3; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
case 6, 
   Nvert=2;Nhor=3;H_Sz=(HorSz-80)/3; V_Sz=(VerSz-120)/2;
   figure('Position',[30 VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-30-V_Sz H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30 VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+H_Sz VerSz-2*V_Sz-75 H_Sz V_Sz]);colormap(gray(256))
   figure('Position',[30+2*H_Sz VerSz-75-2*V_Sz H_Sz V_Sz]);colormap(gray(256))
end
       